
/**
 * Pica - mon infographiste est un script-. 
 par maximeArchambault.com
 Help on the processing forum from: GoToLoop, TfGuy44, koogs, benja, 

 */

static final int ICONS = 8;  
PImage[] icons = new PImage[ICONS];

float x;
float y; 
int s; 
float s2;
float treshold = 150;
int imgNum; 
int rx;
int ry;
int totalSketch= 500;

int col1 = color(255, 255, 255); // couleur du png original à changer blanc
int col2= color(255, 0, 255); // couleur du png original à changer rose

PGraphics output; 

void setup() {
  size(800, 1000);
  output = createGraphics(800, 1000, JAVA2D);
  imageMode(CENTER);
  smooth();
  for (int i = 0; i < ICONS; i++) {
    icons[i] = loadImage (i+".png");
  }
} 


void draw() {
  color [] colarray = { color(253, 230, 0), color(28, 66, 167), 
    color(242, 102, 100), color(109, 211, 195) 
    , color(59, 171, 99), color(210)};  

  shuffleIntArray(colarray);// mélange les couleurs

  int imgCol1 = colarray[1];
  int imgCol2 = colarray[2];
  int imgCol3 = colarray[3];

  background(imgCol1);

  shuffleArray(icons);

  output = createGraphics(800, 1000, JAVA2D);

  output.beginDraw();
  translate(50, 50);
  ImagePosition();
  ImagePosition();
  ImagePosition();
  ImagePosition();
  ImagePosition();
  // ImagePosition();
  output.endDraw();

  output.loadPixels();

 
  for ( int i=0; i<output.pixels.length; i++) { 
    int curPix = output.pixels[i];
    float colDist = dist(red(col1), green(col1), blue(col1), 
    red(curPix), green(curPix), blue(curPix));
    float colDist2 = dist(red(col2), green(col2), blue(col2), 
    red(curPix), green(curPix), blue(curPix));
    if ( colDist <= treshold) { 
      output.pixels[i] = imgCol3;
    }
    if ( colDist2 <= treshold) { 
      output.pixels[i] = imgCol2;
    }
  }

  output.updatePixels();

  image(output, width*0.5, height*0.5);

  if (frameCount> totalSketch) {
    exit();
  }
  saveFrame();
}


void ImagePosition() {

  x= int(random (0, 4))*200; 
  y= int(random (0, 6))*200; 
  s= int(random(1, 5))*100; 
  
  if (imgNum>7) {  
    imgNum=0;
  }
  output.image(icons[imgNum], x, y, s, s);
  imgNum=imgNum+1; 
}

int[] shuffleIntArray(int... arr) {
  for (int rnd, tmp, idx = arr.length; idx > 1; 
    rnd = (int) random(idx--), 
    tmp = arr[idx], arr[idx] = arr[rnd], arr[rnd] = tmp);

  return arr;
}

<T> T[] shuffleArray(T... arr) {
  T tmp;

  for (int rnd, idx = arr.length; idx > 1; 
    rnd = (int) random(idx--), 
    tmp = arr[idx], arr[idx] = arr[rnd], arr[rnd] = tmp);

  return arr;
}